/*!
 * Author : Matteo Bruni
 * MIT license: https://opensource.org/licenses/MIT
 * Demo / Generator : https://particles.js.org/
 * GitHub : https://www.github.com/matteobruni/tsparticles
 * How to use? : Check the GitHub README
 * v3.0.2
 */
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("@tsparticles/engine"));
	else if(typeof define === 'function' && define.amd)
		define(["@tsparticles/engine"], factory);
	else {
		var a = typeof exports === 'object' ? factory(require("@tsparticles/engine")) : factory(root["window"]);
		for(var i in a) (typeof exports === 'object' ? exports : root)[i] = a[i];
	}
})(this, (__WEBPACK_EXTERNAL_MODULE__533__) => {
return /******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ 533:
/***/ ((module) => {

module.exports = __WEBPACK_EXTERNAL_MODULE__533__;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
(() => {
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  initPjs: () => (/* binding */ initPjs)
});

// EXTERNAL MODULE: external {"commonjs":"@tsparticles/engine","commonjs2":"@tsparticles/engine","amd":"@tsparticles/engine","root":"window"}
var engine_root_window_ = __webpack_require__(533);
;// CONCATENATED MODULE: ./dist/browser/marcbruederlin/Particles.js

class Particles {
  static init(options) {
    const particles = new Particles(),
      selector = options.selector;
    if (!selector) {
      throw new Error("No selector provided");
    }
    const el = document.querySelector(selector);
    if (!el) {
      throw new Error("No element found for selector");
    }
    engine_root_window_.tsParticles.load({
      id: selector.replace(".", "").replace("!", ""),
      element: el,
      options: {
        fullScreen: {
          enable: false
        },
        particles: {
          color: {
            value: options.color ?? "!000000"
          },
          links: {
            color: "random",
            distance: options.minDistance ?? 120,
            enable: options.connectParticles ?? false
          },
          move: {
            enable: true,
            speed: options.speed ?? 0.5
          },
          number: {
            value: options.maxParticles ?? 100
          },
          size: {
            value: {
              min: 1,
              max: options.sizeVariations ?? 3
            }
          }
        },
        responsive: options.responsive?.map(responsive => ({
          maxWidth: responsive.breakpoint,
          options: {
            particles: {
              color: {
                value: responsive.options?.color
              },
              links: {
                distance: responsive.options?.minDistance,
                enable: responsive.options?.connectParticles
              },
              number: {
                value: options.maxParticles
              },
              move: {
                enable: true,
                speed: responsive.options?.speed
              },
              size: {
                value: responsive.options?.sizeVariations
              }
            }
          }
        }))
      }
    }).then(container => {
      particles._container = container;
    });
    return particles;
  }
  destroy() {
    const container = this._container;
    container && container.destroy();
  }
  pauseAnimation() {
    const container = this._container;
    container && container.pause();
  }
  resumeAnimation() {
    const container = this._container;
    container && container.play();
  }
}
;// CONCATENATED MODULE: ./dist/browser/VincentGarreau/particles.js

const defaultPjsOptions = {
  particles: {
    number: {
      value: 400,
      density: {
        enable: true,
        value_area: 800
      }
    },
    color: {
      value: "#fff"
    },
    shape: {
      type: "circle",
      stroke: {
        width: 0,
        color: "#ff0000"
      },
      polygon: {
        nb_sides: 5
      },
      image: {
        src: "",
        width: 100,
        height: 100
      }
    },
    opacity: {
      value: 1,
      random: false,
      anim: {
        enable: false,
        speed: 2,
        opacity_min: 0,
        sync: false
      }
    },
    size: {
      value: 20,
      random: false,
      anim: {
        enable: false,
        speed: 20,
        size_min: 0,
        sync: false
      }
    },
    line_linked: {
      enable: true,
      distance: 100,
      color: "#fff",
      opacity: 1,
      width: 1
    },
    move: {
      enable: true,
      speed: 2,
      direction: "none",
      random: false,
      straight: false,
      out_mode: "out",
      bounce: false,
      attract: {
        enable: false,
        rotateX: 3000,
        rotateY: 3000
      }
    }
  },
  interactivity: {
    detect_on: "canvas",
    events: {
      onhover: {
        enable: true,
        mode: "grab"
      },
      onclick: {
        enable: true,
        mode: "push"
      },
      resize: true
    },
    modes: {
      grab: {
        distance: 100,
        line_linked: {
          opacity: 1
        }
      },
      bubble: {
        distance: 200,
        size: 80,
        duration: 0.4,
        opacity: 1,
        speed: 3
      },
      repulse: {
        distance: 200,
        duration: 0.4
      },
      push: {
        particles_nb: 4
      },
      remove: {
        particles_nb: 2
      }
    }
  },
  retina_detect: false
};
const initParticlesJS = engine => {
  const particlesJS = (tagId, options) => {
    const fixedOptions = (0,engine_root_window_.deepExtend)(defaultPjsOptions, options);
    return engine.load({
      id: tagId,
      options: {
        fullScreen: {
          enable: false
        },
        detectRetina: fixedOptions.retina_detect,
        smooth: true,
        interactivity: {
          detectsOn: fixedOptions.interactivity.detect_on,
          events: {
            onHover: {
              enable: fixedOptions.interactivity.events.onhover.enable,
              mode: fixedOptions.interactivity.events.onhover.mode
            },
            onClick: {
              enable: fixedOptions.interactivity.events.onclick.enable,
              mode: fixedOptions.interactivity.events.onclick.mode
            },
            resize: {
              enable: fixedOptions.interactivity.events.resize
            }
          },
          modes: {
            grab: {
              distance: fixedOptions.interactivity.modes.grab.distance,
              links: {
                opacity: fixedOptions.interactivity.modes.grab.line_linked.opacity
              }
            },
            bubble: {
              distance: fixedOptions.interactivity.modes.bubble.distance,
              size: fixedOptions.interactivity.modes.bubble.size,
              duration: fixedOptions.interactivity.modes.bubble.duration,
              opacity: fixedOptions.interactivity.modes.bubble.opacity,
              speed: fixedOptions.interactivity.modes.bubble.speed
            },
            repulse: {
              distance: fixedOptions.interactivity.modes.repulse.distance,
              duration: fixedOptions.interactivity.modes.repulse.duration
            },
            push: {
              quantity: fixedOptions.interactivity.modes.push.particles_nb
            },
            remove: {
              quantity: fixedOptions.interactivity.modes.remove.particles_nb
            }
          }
        },
        particles: {
          collisions: {
            enable: fixedOptions.particles.move.bounce
          },
          number: {
            value: fixedOptions.particles.number.value,
            density: {
              enable: fixedOptions.particles.number.density.enable,
              width: fixedOptions.particles.number.density.value_area
            }
          },
          color: {
            value: fixedOptions.particles.color.value
          },
          stroke: {
            width: fixedOptions.particles.shape.stroke.width,
            color: {
              value: fixedOptions.particles.shape.stroke.color
            }
          },
          shape: {
            type: fixedOptions.particles.shape.type,
            options: {
              polygon: {
                sides: fixedOptions.particles.shape.polygon.nb_sides
              },
              image: {
                src: fixedOptions.particles.shape.image.src,
                width: fixedOptions.particles.shape.image.width,
                height: fixedOptions.particles.shape.image.height
              }
            }
          },
          opacity: {
            value: fixedOptions.particles.opacity.random ? {
              min: fixedOptions.particles.opacity.anim.enable ? fixedOptions.particles.opacity.anim.opacity_min : 0,
              max: fixedOptions.particles.opacity.value
            } : fixedOptions.particles.opacity.value,
            animation: {
              enable: fixedOptions.particles.opacity.anim.enable,
              speed: fixedOptions.particles.opacity.anim.speed,
              sync: fixedOptions.particles.opacity.anim.sync
            }
          },
          size: {
            value: fixedOptions.particles.size.random ? {
              min: fixedOptions.particles.size.anim.enable ? fixedOptions.particles.size.anim.size_min : 0,
              max: fixedOptions.particles.size.value
            } : fixedOptions.particles.size.value,
            animation: {
              enable: fixedOptions.particles.size.anim.enable,
              speed: fixedOptions.particles.size.anim.speed,
              sync: fixedOptions.particles.size.anim.sync
            }
          },
          links: {
            enable: fixedOptions.particles.line_linked.enable,
            distance: fixedOptions.particles.line_linked.distance,
            color: fixedOptions.particles.line_linked.color,
            opacity: fixedOptions.particles.line_linked.opacity,
            width: fixedOptions.particles.line_linked.width
          },
          move: {
            enable: fixedOptions.particles.move.enable,
            speed: fixedOptions.particles.move.speed / 3,
            direction: fixedOptions.particles.move.direction,
            random: fixedOptions.particles.move.random,
            straight: fixedOptions.particles.move.straight,
            outModes: fixedOptions.particles.move.out_mode,
            attract: {
              enable: fixedOptions.particles.move.attract.enable,
              rotate: {
                x: fixedOptions.particles.move.attract.rotateX,
                y: fixedOptions.particles.move.attract.rotateY
              }
            }
          }
        }
      }
    });
  };
  particlesJS.load = (tagId, pathConfigJson, callback) => {
    engine.load({
      id: tagId,
      url: pathConfigJson
    }).then(container => {
      if (container) {
        callback(container);
      }
    }).catch(() => {
      callback(undefined);
    });
  };
  particlesJS.setOnClickHandler = callback => {
    engine.setOnClickHandler(callback);
  };
  const pJSDom = engine.dom();
  return {
    particlesJS,
    pJSDom
  };
};

;// CONCATENATED MODULE: ./dist/browser/index.js


const initPjs = engine => {
  const {
    particlesJS,
    pJSDom
  } = initParticlesJS(engine);
  window.particlesJS = particlesJS;
  window.pJSDom = pJSDom;
  window.Particles = Particles;
  return {
    particlesJS,
    pJSDom,
    Particles: Particles
  };
};

})();

/******/ 	return __webpack_exports__;
/******/ })()
;
});